//自定义多边形


//生成单个多边形。用于显示自定义多边形
//与2的区分在于传递的参数不同，以及这个没有设置鼠标事件，只显示多边形
export function addPolygon(path, map) {
    let polygon = new AMap.Polygon({
        path: path,
        fillColor: '#ccebc5',
        strokeOpacity: 1,
        fillOpacity: 0.2,
        strokeColor: '#2b8cbe',
        strokeWeight: 1,
        strokeStyle: 'dashed',
        strokeDasharray: [5, 5],
    });

    map.add(polygon)

    return polygon
}

//随机生成五位混合字母和数字的字符串
export function randomKey() {
    var length = 5; // 定义字符串长度
    var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var result = '';
    for (var i = 0; i < length; i++) {
        result += chars.charAt(Math.floor(Math.random() * chars.length));
    }
    return result;
}


// 查找poi，返回结果中的第一个值
export async function poiSearchOne(path) {
    let polygonArr = path;

    console.log('polygonArr', polygonArr);

    return new Promise((resolve) => {
        AMap.plugin("AMap.PlaceSearch", function () {
            let placeSearch = new AMap.PlaceSearch({
                city: "天津市",
            });

            placeSearch.searchInBounds("教育机构", polygonArr, function (status, result) {
                console.log('教育机构res：', result);
                if (status === 'complete' && result.info === 'OK' && result.poiList.pois.length > 0) {
                    console.log('result.poiList.pois[0].name', result.poiList.pois[0].name);
                    resolve(result.poiList.pois[0].name); // 使用resolve返回结果
                } else {
                    resolve('无此类建筑')
                }
            });
        });
    });
}

// 踩坑后做判断用。
// 判断交集的方法有时会报错，说传入的参数是不合法的图形。当时用这个函数判断了一下
// 后来发现是构造的时候出现问题
// turf的多边形构造和高德的不一样。
// 1.turf用的是[...[经度，纬度]]，高德用的是他自己封装的坐标对。
// 2.turf的path必须是第一个坐标和最后一个坐标相同，即【绘制路线是封口的。图形是封闭图形】。但是高德的开口也可以，默认最后一个点会链接到第一个点去
// 3.接2，中间的其他坐标有连续相同的不影响。
export function isGeometry(obj) {
    const geometryTypes = [
        'Point',
        'LineString',
        'Polygon',
        'MultiPoint',
        'MultiLineString',
        'MultiPolygon',
        'GeometryCollection'
    ];

    // 检查是否为对象，并且具有type属性
    if (typeof obj === 'object' && obj !== null && 'type' in obj) {
        // 检查type属性是否为Geometry类型
        return geometryTypes.includes(obj.type);
    }

    // 如果不满足条件，则不是Geometry
    return false;
}

